<?php
/**
 *   Handler class for system Maintainance
 *
 *   @author Viktor Zeman
 *   @copyright Copyright (c) Quality Unit s.r.o.
 *   @package SupportCenter
 */

QUnit::includeClass("QUnit_Rpc_Service");
class App_Service_ExecutionController extends QUnit_Rpc_Service {

    var $arr_start;

    function initMethod($params) {
        $method = $params->get('method');

        switch($method) {
            default:
                return false;
                break;
        }
    }

    function getExecutionTime() {
        $arr_end = gettimeofday();

        $delay_sec = $arr_end['sec'] - $this->arr_start['sec'];
        $delay_usec = $arr_end['usec'] - $this->arr_start['usec'];
        if ($delay_usec < 0) {
            $delay_sec--;
            $delay_usec = 1000000 + $delay_usec;
        }
        $delay_usec = str_repeat('0', 6 - strlen($delay_usec)) . $delay_usec;
        return  $delay_sec + $delay_usec/1000000;
    }


    function setRunning($isRunning = true) {
        $paramsSettings = $this->createParamsObject();
        if ($isRunning) {
            if ($this->arr_start == null) {
                $this->arr_start = gettimeofday();
            }
            $paramsSettings->setField('lastExecution', time());
            $this->callService('Settings', 'updateSetting', $paramsSettings);
        } else {
            $paramsSettings->set('setting_key', 'lastExecution');
            $this->callService('Settings', 'deleteSetting', $paramsSettings);
            $this->state->log('info', 'jobs.php execution time: ' . $this->getExecutionTime(), 'jobs.php');
        }
    }

    function canStartProcess() {
        if (!$this->state->config->get('lastExecution')) {
            return true;
        }
        if (time() - $this->state->config->get('lastExecution') > 1800) {
            return true;
        }
        return false;
    }

}
?>
